SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell commentStamp: 'BriceGovin 7/23/2014 21:42' prior: 0!
A LOCell is a cell for the first application described in Pharo by Example.

Instance Variables
	mouseAction:		<Object>

mouseAction
	- xxxxx
!

!LOCell methodsFor: 'initialization' stamp: 'BriceGovin 7/23/2014 21:44'!
initialize 
	"Initialize method"

	super initialize.
	self label:''.
	self borderWidth: 2.
	bounds := 0@0 corner:  16@16.
	offColor := Color  paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff
	! !

!LOCell methodsFor: 'accessing' stamp: 'BriceGovin 7/23/2014 22:58'!
mouseAction: aBlock
	"Setter"

	^mouseAction := aBlock ! !

!LOCell methodsFor: 'event handling' stamp: 'BriceGovin 7/23/2014 23:24'!
mouseMove: anEvent! !

!LOCell methodsFor: 'event handling' stamp: 'BriceGovin 7/23/2014 23:00'!
mouseUp: anEvent
	"Action wehn click"

	mouseAction value! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame commentStamp: 'BriceGovin 7/23/2014 22:10' prior: 0!
A LOGame is a game for the first application of Pharo by Example.

Instance Variables
!

!LOGame methodsFor: 'initialization' stamp: 'BriceGovin 7/23/2014 22:42'!
cellsPerSide
	"The number of cells along each side of the table"
	^10.! !

!LOGame methodsFor: 'initialization' stamp: 'BriceGovin 7/23/2014 22:16'!
initialize 
	"Initialize method for the game"

	|sampleCell width height n|
	super initialize .
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell  height.
	self bounds: (5@5 extent: ((width*n)@(height*n))+(2*self borderWidth)).
	cells := Matrix new: n tabulate: [:i :j| self newCellAt:i at:j].! !

!LOGame methodsFor: 'initialization' stamp: 'BriceGovin 7/23/2014 23:15'!
newCellAt: i at: j
	"Creates a cell at case (i,j) of the matrix game"
	|c origin|
	c := LOCell  new.
	origin := self innerBounds origin .
	self addMorph: c.
	c position: ((i-1)*c width )@((j-1)*c height ) + origin.
	c mouseAction:[self toggleNeighboursOfCellAt: i at: j].
	^c ! !

!LOGame methodsFor: 'game logic' stamp: 'BriceGovin 7/23/2014 23:21'!
toggleNeighboursOfCellAt: i at: j
	""
(i > 1) ifTrue: [ (cells at: i-1 at: j ) toggleState].
(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
(j > 1) ifTrue: [ (cells at: i at: j-1) toggleState].
(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].! !
